# Contributing

This document is not intended to significantly alter the methods through which You, the contributor, help out the project. It is sincerely believed that the ways through which You contribute are most likely the right ways, and that establishing a formal process for that could deteriorate the insight that Your contributions give.

Because of that, this document will only make clear the norms around contributing to the project, as follows:

* **By the term "contributing", we understand any actions undertaken with the intent to make the project better...**
* **...and by the term "contributing to the project's repository", we understand a pull request.** It's that simple!
* **By contributing to the project's repository, You forfeit any individual claims to the work contributed.** In other words, the repository in the state right after Your contribution must stay the sole property of the original copyright holders, forever licensed to You under the terms specified at the time of Your contribution. No contributions that attempt to change the copyright holders will be accepted, as this presents a risk that the contributors may later want to revoke their license.
* **When contributing to the project's repository, please contribute to the `develop` branch.** The other branches are there either for focused development, or for full-fledged releases.
* **When contributing to the project's repository, please try to ensure that the contribution is going to benefit many of the project's users, and hurt no one.** Breaking compatibility is usually a problem. When in doubt, however, contribute!
* Last but not least, **please assume good faith on part of the person reviewing Your contribution.** If they happen to say "no", there is probably a solid reason behind that decision. They are not here to make Your life miserable, and if it seems so, it's probably just a minor personality clash. The person reviewing Your contribution will do their best to abide by this as well.

Thank You for taking the time to read this document and contribute.
